SystemOrganization addCategory: #TimeComputer!

Object subclass: #TCDeadline
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TimeComputer'!

Object subclass: #TCTask
	instanceVariableNames: 'name duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TimeComputer'!

!TCTask methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 16:56'!
duration
	^ duration! !

!TCTask methodsFor: 'changing' stamp: 'HwaJong 8/17/2013 16:54'!
duration: aDuration 
	duration := aDuration ! !

!TCTask methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 17:14'!
name
	^name! !

!TCTask methodsFor: 'changing' stamp: 'HwaJong 8/17/2013 16:54'!
name: aString 
	name := aString! !

!TCTask methodsFor: 'answering' stamp: 'HwaJong 8/20/2013 10:34'!
taskListWrap
	^Array with: name with: duration printNatrually! !

Object subclass: #TimeComputer
	instanceVariableNames: 'tasks deadline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TimeComputer'!

!TimeComputer methodsFor: 'changing' stamp: 'HwaJong 8/17/2013 16:53'!
addTask: aString taking: aDuration 
	self tasks add: (TCTask new name: aString; duration: aDuration)! !

!TimeComputer methodsFor: 'answering' stamp: 'HwaJong 8/18/2013 14:32'!
availableTime
	^self deadline asDateAndTime - self completionTime asDateAndTime.! !

!TimeComputer methodsFor: 'answering' stamp: 'HwaJong 9/12/2013 14:28'!
completionTime
	^DateAndTime now + self sumOfTaskDurations.! !

!TimeComputer methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 17:02'!
deadline
	^ deadline! !

!TimeComputer methodsFor: 'changing' stamp: 'HwaJong 8/17/2013 17:01'!
deadline: aDateAndTime 
	deadline := aDateAndTime! !

!TimeComputer methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 16:53'!
defaultTasks
	^OrderedCollection new! !

!TimeComputer methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 17:16'!
listTasks
	^self tasks keysAndValuesCollect: [:index :each| {each name. each duration}]! !

!TimeComputer methodsFor: 'changing' stamp: 'HwaJong 8/17/2013 17:15'!
removeTaskAtIndex: anInteger 
	self tasks removeAt: anInteger! !

!TimeComputer methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 17:07'!
sumOfTaskDurations
	^self tasks inject: 0 seconds into: [:time :task| task duration + time]! !

!TimeComputer methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 16:53'!
tasks
	^tasks setDefault: #defaultTasks for: self withSetter: #tasks:! !

!TimeComputer methodsFor: 'changing' stamp: 'HwaJong 8/17/2013 16:54'!
tasks: anOrderedCollection 
	tasks := anOrderedCollection! !

Object subclass: #TimeComputerController
	instanceVariableNames: 'model taskListModel updatingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TimeComputer'!

!TimeComputerController classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/23/2013 14:28'!
initialize 
	Smalltalk addToStartUpList: self! !

!TimeComputerController classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/20/2013 09:07'!
open
	^self new open! !

!TimeComputerController classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 8/23/2013 15:57'!
startUp: systemIsQuiting

	self allSubInstances do: [:instance| instance imageStartUp: systemIsQuiting ].! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/20/2013 10:32'!
addModelItemsToWindowMenu: aMenu

	super addModelItemsToWindowMenu: aMenu.
	aMenu addLine.
	aMenu add: 'inspect model' target: self action: #inspect.
	aMenu add: 'inspect window' target: (aMenu defaultTarget) action: #inspect.! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/19/2013 13:39'!
addTask
	|taskName durationStr|
	taskName := UIManager default request: 'name' initialAnswer: 'walk my dog' title: 'Adding Task'.
	taskName isEmptyOrNil ifTrue: [^self].
	durationStr := UIManager default request: 'duration' initialAnswer: '10 minutes' title: 'Adding Task "', taskName, '"'.
	durationStr isEmptyOrNil ifTrue: [^self].
	self addTask: taskName taking: (Compiler evaluate: durationStr).! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/20/2013 10:39'!
addTask: aString taking: aDuration 
	self taskListModel insertAfterSelection: (TCTask new name: aString; duration: aDuration).
	self changed: #taskList.
	self updateTimeGUI.	! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 9/12/2013 11:41'!
arrowKey: aCharacter from: aPluggableMultiColumnListMorph 
	aCharacter = $j
		ifTrue: [self taskListModel moveSelectionDown. self changed: #taskList. self changed: #taskListIndex.^self].
	aCharacter = $k
		ifTrue: [self taskListModel moveSelectionUp. self changed: #taskList. self changed: #taskListIndex.^self].
	aCharacter =  $n
		ifTrue: [self addTask. ^self].
	aCharacter =  $x
		ifTrue: [self deleteSelectedTask. ^self].
	aCharacter =  $t
		ifTrue: [self changeDurationOfSelectedTask. ^self].	
	self error: 'not supported key'! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 9/12/2013 11:52'!
changeDurationOfSelectedTask
	self taskListModel 
		ifHasSelection: [:selection|
			|durationStr|
			durationStr := UIManager default request: 'duration' initialAnswer: (selection duration printAnsiExpression) title: 'Change task "', selection name, '"'.
			durationStr isEmptyOrNil ifTrue: [^self].
			selection duration: (Compiler evaluate: durationStr).
			self changed: #taskList]! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/19/2013 13:25'!
dateAndTimeAsInitialAnswerForSetDeadline
	|dt|
	dt := self model deadline.
	^dt isNil 
		ifTrue: [dt := DateAndTime now. (DateAndTime year: dt year month: dt month day: dt dayOfMonth hour: dt hour minute: dt minute)] 
		ifFalse: [dt]	! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/20/2013 10:39'!
deadline: aDateAndTime 
	self model deadline: aDateAndTime.
	self updateTimeGUI.
! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/18/2013 15:08'!
deadlineString
	^self model deadline
		ifNil: ['no deadline']
		ifNotNil: [self model deadline printString] ! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 17:42'!
defaultModel
	^TimeComputer new! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/18/2013 14:12'!
defaultTaskListModel
	^TGListModel new list: (IndirectArrayForTGListModel new source: self model; getter: #tasks; setter: #tasks:)! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/19/2013 13:14'!
deleteDeadline
	self deadline: nil.! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/20/2013 10:39'!
deleteSelectedTask
	self taskListModel deleteSelection.
	self changed: #taskList.
	self changed: #taskListIndex.
	self updateTimeGUI.! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 9/8/2013 18:20'!
imageStartUp: systemIsQuiting
	systemIsQuiting
		ifTrue: [updatingProcess resume].! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/19/2013 11:48'!
initialize 
	super initialize.
	updatingProcess := [] fork.! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/17/2013 17:42'!
model
	^model setDefault: #defaultModel for: self withSetter: #model:! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/17/2013 17:42'!
model: aTimeComputer 
	model := aTimeComputer! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/19/2013 14:02'!
myWIndows
	^SystemWindow allInstances select: [:win| win model == self ].! !

!TimeComputerController methodsFor: 'doing' stamp: 'HwaJong 8/19/2013 14:10'!
open
	|q window|
	q := QuickPrototyping for: self.
	window := q window: 'Time Computer' content: 
		(q column: {
			q staticLabel: 'tasks'. 
			(q multiList: #taskList index: #taskListIndex wrap: #taskListWrap) beSpaceFilling.
			q row: {q button: 'enter' action: #addTask.
			q button: 'del' action: #deleteSelectedTask}.
			(q groupedRow: {q staticLabel: 'deadline: '. q label: #deadlineString. q button: 'set' action: #setDeadline. q button: 'del' action: #deleteDeadline.}) beHorizontalFillingWithHeight: 35.
			(q title: 'free time: ' label: #timeLeftString).}).
	window extent:  (355.0@315.0).
	window model: self.
	self startTheUpdatingProcess.
	^window! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/19/2013 14:03'!
release
	self myWIndows size = 1
		ifTrue: [self stopTheUpdatingProcess].
	super release.! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/19/2013 13:24'!
setDeadline
	|str|
	str := UIManager default request: 'deadline:' initialAnswer: (self dateAndTimeAsInitialAnswerForSetDeadline) printString.
	str isEmptyOrNil
		ifFalse: [self deadline: (DateAndTime fromString: str)]
	! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 9/8/2013 17:37'!
startTheUpdatingProcess
	self stopTheUpdatingProcess.
	updatingProcess := 
		[
			[self updateTimeGUI.
			(Delay forDuration: 1 seconds) wait] repeat.
		] fork.
	updatingProcess name: 'TimeComputer updator'! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/19/2013 11:44'!
stopTheUpdatingProcess
	updatingProcess terminate.! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/18/2013 14:14'!
taskList
	^self taskListModel list! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/18/2013 14:14'!
taskListIndex
	^self taskListModel selectionIndex! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/18/2013 14:15'!
taskListIndex: anInteger 
	self taskListModel selectionIndex: anInteger.
	self changed: #taskListIndex! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/18/2013 14:08'!
taskListModel
	^ taskListModel setDefault: #defaultTaskListModel for: self withSetter: #taskListModel:! !

!TimeComputerController methodsFor: 'changing' stamp: 'HwaJong 8/18/2013 14:09'!
taskListModel: aTGListModel 
	taskListModel := aTGListModel! !

!TimeComputerController methodsFor: 'answering' stamp: 'HwaJong 8/20/2013 09:15'!
timeLeftString
	^[self model availableTime printNatrually] on: MessageNotUnderstood do: [:mnu| 'N/A' ]! !

!TimeComputerController methodsFor: 'doing' stamp: 'HwaJong 8/18/2013 15:19'!
updateGUI
	self changed: #taskList.
	self changed: #taskListIndex.
	self changed: #deadlineString.
	self changed: #timeLeftString.
! !

!TimeComputerController methodsFor: 'doing' stamp: 'HwaJong 8/20/2013 10:12'!
updateTimeGUI
	self changed: #deadlineString.
	self changed: #timeLeftString.
! !

TextEntryDialogWindow subclass: #EnterTaskAndDurationDialogWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TimeComputer'!

!Duration methodsFor: '*TimeComputer' stamp: 'HwaJong 9/12/2013 11:52'!
printAnsiExpression
	^String streamContents: [:stream| self printAnsiExpressionOn: stream ]! !

!Duration methodsFor: '*TimeComputer' stamp: 'HwaJong 9/12/2013 11:58'!
printAnsiExpressionOn: aStream
 	| d h m s n printedAny |
	d := self days abs.
	h := self hours abs.
	m := self minutes abs.
 	s := self seconds abs truncated.
	n := self nanoSeconds abs. 	self negative ifTrue: [ aStream nextPut: $- ].
	printedAny := false.
	d>0 ifTrue: 
		[printedAny ifTrue: [aStream nextPutAll: ' + ']. printedAny := true. d printOn: aStream. aStream nextPutAll: ' days'].
	h>0 ifTrue:
		[printedAny ifTrue: [aStream nextPutAll: ' + ']. printedAny := true. h printOn: aStream. aStream nextPutAll: ' hours'].
	m>0 ifTrue:
		[printedAny ifTrue: [aStream nextPutAll: ' + ']. printedAny := true. m printOn: aStream. aStream nextPutAll: ' minutes'].
	s>0 ifTrue:
		[printedAny ifTrue: [aStream nextPutAll: ' + ']. printedAny := true. s printOn: aStream. aStream nextPutAll: ' seconds'].
	n = 0 ifFalse:
		[printedAny ifTrue: [aStream nextPutAll: ' + ']. printedAny := true. n printOn: aStream. aStream nextPutAll: ' nanoSeconds'].
! !

!Duration methodsFor: '*TimeComputer' stamp: 'HwaJong 8/20/2013 09:12'!
printNatrually
	^String streamContents: [:stream| self printNatruallyOn: stream ]! !

!Duration methodsFor: '*TimeComputer' stamp: 'HwaJong 8/20/2013 10:35'!
printNatruallyOn: aStream
 	| d h m s n |
	d := self days abs.
	h := self hours abs.
	m := self minutes abs.
 	s := self seconds abs truncated.
	n := self nanoSeconds abs. 	self negative ifTrue: [ aStream nextPut: $- ].
	d>0 ifTrue: 
		[d printOn: aStream. aStream nextPut: $d].
	h>0 ifTrue:
		[h printOn: aStream. aStream nextPut: $h].
	m>0 ifTrue:
		[m printOn: aStream. aStream nextPut: $m].
	s>0 ifTrue:
		[s printOn: aStream. aStream nextPut: $s].
	n = 0 ifFalse:
		[ | z ps |
		aStream nextPut: $..
		ps := n printString padded: #left to: 9 with: $0. 
		z := ps findLast: [ :c | c asciiValue > $0 asciiValue ].
		ps from: 1 to: z do: [ :c | aStream nextPut: c ] ].
! !
TimeComputerController initialize!
